# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 rule27 rule28 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26,rule27,rule28 ]) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.TemplateModel",
        
        shipper : rule1,
        receiver : rule3,
        deliverable : rule5,
        businessDays : rule15,
        attachment : rule27
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "Acceptance of Delivery. " 


rule1 -> String {% id %} # shipper 


rule2 -> " will be deemed to have completed its delivery obligations if in " 


rule3 -> String {% id %} # receiver 


rule4 -> "'s opinion, the " 


rule5 -> String {% id %} # deliverable 


rule6 -> " satisfies the Acceptance Criteria, and " 


rule7 -> String {% id %} # receiver 


rule8 -> " notifies " 


rule9 -> String {% id %} # shipper 


rule10 -> " in writing that it is accepting the " 


rule11 -> String {% id %} # deliverable 


rule12 -> ".\n\nInspection and Notice. " 


rule13 -> String {% id %} # receiver 


rule14 -> " will have " 


rule15 -> Long {% id %} # businessDays 


rule16 -> " Business Days' to inspect and evaluate the " 


rule17 -> String {% id %} # deliverable 


rule18 -> " on the delivery date before notifying " 


rule19 -> String {% id %} # shipper 


rule20 -> " that it is either accepting or rejecting the " 


rule21 -> String {% id %} # deliverable 


rule22 -> ".\n\nAcceptance Criteria. The \"Acceptance Criteria\" are the specifications the " 


rule23 -> String {% id %} # deliverable 


rule24 -> " must meet for the " 


rule25 -> String {% id %} # shipper 


rule26 -> " to comply with its requirements and obligations under this agreement, detailed in " 


rule27 -> String {% id %} # attachment 


rule28 -> ", attached to this agreement." 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


InspectDeliverable -> DateTime  __  Boolean  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.InspectDeliverable",
        deliverableReceivedAt : data[0],
        inspectionPassed : data[2],
        transactionId : data[4],
        timestamp : data[6]
    };
}
%}


InspectionStatus -> "PASSED_TESTING" {% id %} | "FAILED_TESTING" {% id %} | "OUTSIDE_INSPECTION_PERIOD" {% id %} 


InspectionResponse -> InspectionStatus  __  String  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.InspectionResponse",
        status : data[0],
        shipper : data[2],
        receiver : data[4],
        transactionId : data[6],
        timestamp : data[8]
    };
}
%}



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}